"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@babel/types");
const requireReplacements = {
    flipper: 'global.Flipper',
    react: 'global.React',
    'react-dom': 'global.ReactDOM',
    adbkit: 'global.adbkit',
};
function tryReplaceFlipperRequire(path) {
    const node = path.node;
    const args = node.arguments || [];
    if (node.callee.type === 'Identifier' &&
        node.callee.name === 'require' &&
        args.length === 1 &&
        types_1.isStringLiteral(args[0])) {
        const replacement = requireReplacements[args[0].value];
        if (replacement) {
            path.replaceWith(types_1.identifier(replacement));
            return true;
        }
    }
    return false;
}
exports.tryReplaceFlipperRequire = tryReplaceFlipperRequire;
function tryReplaceGlobalReactUsage(path) {
    if (path.node.name === 'React' &&
        path.parentPath.node.id !== path.node &&
        !isReactImportIdentifier(path)) {
        path.replaceWith(types_1.identifier('global.React'));
        return true;
    }
    return false;
}
exports.tryReplaceGlobalReactUsage = tryReplaceGlobalReactUsage;
function isReactImportIdentifier(path) {
    return (path.parentPath.node.type === 'ImportNamespaceSpecifier' &&
        path.parentPath.node.local.name === 'React');
}
//# sourceMappingURL=replace-flipper-requires.js.map